﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerController : MonoBehaviour
{

    public float speed = 6.0F;
    public float turnSpeed = 1F;
    private Vector3 moveDirection = Vector3.zero;
    private CharacterController controller;
    private GameObject playerObject;
    private GameObject fishingRodObject;
    private bool isFishing = false;
    private string rodState = "carry";

    private Vector3 rodCarry = new Vector3(280f,0f,0f);
    private Vector3 rodCharge = new Vector3(310f, 0f,0f);
    private Vector3 rodCast = new Vector3(320f, 0f, 0f);



    // Start is called before the first frame update
    void Start()
    {
        controller = GetComponent<CharacterController>();
        playerObject = transform.Find("player").gameObject;
        fishingRodObject = transform.Find("player/fishingRod").gameObject;
    }

    // Update is called once per frame
    void Update()
    {

        float moveHorizontal = Input.GetAxis("Horizontal");
        float moveVertical = Input.GetAxis("Vertical");

        moveDirection = new Vector3(moveHorizontal, 0, moveVertical);

        moveDirection = transform.TransformDirection(moveDirection);

        Vector3 moveAmount = moveDirection * speed;

        if (!isFishing)
        {
            controller.Move(moveAmount * Time.deltaTime);

            //rotate player
            if (moveDirection != Vector3.zero)
            {
                playerObject.transform.rotation = Quaternion.Slerp(transform.rotation, Quaternion.LookRotation(moveDirection) * Quaternion.Euler(0, 180f, 0), turnSpeed);
            }
        }

        //fishing control
        if (Input.GetButtonDown("Jump")) {
            switch(rodState) {
                case "carry":
                    rodState = "charging";
                    break;
                case "cast":
                    rodState = "reeling";
                    break;
                default:
                    //Debug.Log("rod state switch key down");
                    break;
            }
        }

        if (Input.GetButtonUp("Jump")) { 
            if(rodState == "charging" || rodState == "maxcharge") {
                rodState = "casting";
            }  
        }

        //rod charging
        if (rodState == "charging") {
            Vector3 currentRodAngle = fishingRodObject.transform.localEulerAngles;
            currentRodAngle.x += 0.2f;
            if (currentRodAngle.x >= rodCharge.x) {
                //rodState = "maxcharge";
            }
            fishingRodObject.transform.localEulerAngles = currentRodAngle;
        }

        //rod casting
        if (rodState == "casting")
        {
            Vector3 currentRodAngle = fishingRodObject.transform.localEulerAngles;
            //Debug.Log(currentRodAngle.x);
            currentRodAngle.x -= 10f;
            if (currentRodAngle.x >= rodCast.x)
            {
                rodState = "cast";
                isFishing = true;
            }
            fishingRodObject.transform.Rotate(new Vector3(-10f, 0, 0));
        }

        //rod casting
        if (rodState == "reeling")
        {
            Vector3 currentRodAngle = fishingRodObject.transform.localEulerAngles;
            //Debug.Log(currentRodAngle.x);
            //currentRodAngle.x -= 1f;

            if (currentRodAngle.x <= rodCarry.x)
            {
                rodState = "carry";
                isFishing = false;
                //reset it's position
                fishingRodObject.transform.localEulerAngles = rodCarry;
            }
            fishingRodObject.transform.Rotate(new Vector3(3f, 0, 0));
        }




    }
}
